#ifndef __S4ITMCTRUTH__
#define __S4ITMCTRUTH__
//*************************************************************************
//* ----------------
//* S4ITMCTruth Class
//* ----------------
//* (Description)
//* (Requires)
//*	S4VMCTruth:
//* (Provides)
//*	S4ITMCTruth		: steering class
//* (Update Record)
//*	2001/08/20  A.Yamaguchi	Original version.
//*************************************************************************

#include "S4VMCTruth.h"
#include "S4ITTypeDef.h"

class S4ITMCTruth : public S4VMCTruth {

public:
   S4ITMCTruth(const Char_t *fname = "hit.dat", 
               const Char_t *name  = "S4ITMCTruth",
               const Char_t *title = "Get IT ExactHit data");
	        
   virtual ~S4ITMCTruth();

   Bool_t BeginRun(Int_t nrun);
   Bool_t Process (Int_t ev);

   void   DebugPrint(const Char_t *opt = "");
   
private:
   Char_t        *fInputFileName;            //!
   std::ifstream *fInputStream;              //!

   ClassDef(S4ITMCTruth, 1) // Read IT ExactHit Data
};

#endif

