#ifndef __S4TPCMCTRUTH__
#define __S4TPCMCTRUTH__
//*************************************************************************
//* ----------------
//* S4TPCMCTruth Class
//* ----------------
//* (Description)
//* (Requires)
//*	S4VMCTruth:
//* (Provides)
//*	S4TPCMCTruth		: steering class
//* (Update Record)
//*	2001/08/20  A.Yamaguchi	Original version.
//*************************************************************************

#include <fstream>
#include "S4VMCTruth.h"
#include "S4TPCTypeDef.h"

class S4TPCMCTruth : public S4VMCTruth {

public:
   S4TPCMCTruth(const Char_t *fname = "hit.dat", 
                const Char_t *name  = "S4TPCMCTruth",
                const Char_t *title = "Get TPC ExactHit data");
	        
   virtual ~S4TPCMCTruth();

   Bool_t BeginRun(Int_t nrun);
   Bool_t Process (Int_t ev);

   void   DebugPrint(const Char_t *opt = "");
   
private:
   Char_t        *fInputFileName;            //!
   std::ifstream *fInputStream;              //!

   ClassDef(S4TPCMCTruth, 1) // Read TPC ExactHit Data
};

#endif

