#ifndef __S4VTXMCTRUTHBUF__
#define __S4VTXMCTRUTHBUF__
//*************************************************************************
//* ----------------
//* S4VMCTruthBuf Class
//* ----------------
//* (Description)
//*	This set of classes reads ascii output of JUPITER and
//*	put them into root objects.
//* (Requires)
//*	S4VMCTruthBuf:
//* (Provides)
//*	S4VMCTruthBuf		: steering class
//* (Update Record)
//*	2004/09/06  A.Yamaguchi	Original version.
//*************************************************************************

#include "S4VMCTruthBuf.h"
#include "S4VTXTypeDef.h"
#include "S4VTXMCTruth.h"

// ---------------
// MonteCarlo Truth Buffer
// ---------------

class S4VTXMCTruthBuf : public S4VMCTruthBuf {

public:
  S4VTXMCTruthBuf(const Char_t *name  = "S4VTXMCTruthBuf",
                  const Char_t *title = "VTX MCTruth Buf", 
                  S4VTXMCTruth *mod =0,
		  Int_t         size = 20000);

  S4VTXMCTruthBuf(S4VTXMCTruth *mod,
                  const Char_t *name = "S4VTXMCTruthBuf",
		  const Char_t *title = "VTX MCTruth Buf",
                  Int_t         size = 20000);

  virtual   ~S4VTXMCTruthBuf();

  TObjArray *GetInputBufPtr()                { return fInputBufPtr; }
  void       SetInputBufPtr(TObjArray *bufp) { fInputBufPtr = bufp; }
  void       MergeHits();

  Bool_t     ReadFile();

private:
  void       CleanUp(TObjArray &obp);       

private:
  TObjArray *fInputBufPtr;             //! 
  
  ClassDef(S4VTXMCTruthBuf, 1) // VTX raw data buffer
};

#endif

