#ifndef __S4BabyTRACKMAKERBUF__
#define __S4BabyTRACKMAKERBUF__

//*************************************************************************
//* ---------------------
//* S4BabyTrackMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes FADC clusters.
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	S4BabyTrackMakerBuf		: buffering class
//* (Update Record)
//*	2002/08/28  R.Kuboshima
//*************************************************************************

#include "U4VTrackMakerBuf.h"
#include "S4BabyTrackMaker.h"
#include "S4BabyTrack.h"
#include "S4BabyVectorHit.h"

class S4BabyTrackMakerBuf : public U4VTrackMakerBuf {
friend class S4BabyTrackMaker;

public:

  S4BabyTrackMakerBuf(const char *name="S4BabyTrackMakerBuf",
	           const char *title="Baby Track data", 
	           S4BabyTrackMaker *module=0, Int_t bufsize = 2000);
  S4BabyTrackMakerBuf(S4BabyTrackMaker *module,
	             const char *name="S4BabyTrackMakerBuf",
	             const char *title="Baby Track data",
	             Int_t bufsize = 2000);
		    
  virtual ~S4BabyTrackMakerBuf();
  
  virtual void 	DebugPrint(const Char_t *opt = "") {}
    
protected:  
  virtual void	MakeTracks() ;	// Make Baby Tracks
    
private:
  void AppendVectorHit(TObjArray *vectorhittmpp,  S4BabyTrack *trackcurp);
  void AppendTrack    (TObjArray *tracktmpp, TObjArray *outputbufp);
  S4BabyTrack *FindTrackByNo(Int_t trackno);
  
  
  ClassDef(S4BabyTrackMakerBuf, 1) // Cluster data buffer
};



#endif













