#ifndef __S4CALNHDCLUSTERMAKER__
#define __S4CALNHDCLUSTERMAKER__

//*************************************************************************   
//* ---------------------                      
//* S4CALNHDClusterMaker Class
//* ---------------------   
//* (Description) 
//*     represent calorimeter cluster
//* (Requires)
//*
//* (Provides)  
//*
//* (Update Record)
//*
//*
//*************************************************************************

#include "S4CALRealCluster.h"
#include "S4CALSmallCluster.h"
#include "S4HYBTrack.h"
#include "TObject.h"

#include <utility>
#include <map>
#include <vector>

class S4CALNHDClusterMaker {

 public:
  S4CALNHDClusterMaker();
  virtual ~S4CALNHDClusterMaker();

 public:

 //---------------------------------------------------------
 // make neutral hadron clusters
 //---------------------------------------------------------
 void MakeNHDClusters(std::map<Int_t,S4CALRealCluster*>  &clmap,
		      std::map<Int_t,S4CALHit*> &hitmap);

 //---------------------------------------------------------
 // Lock definite neutral hadron origined small clusters.
 // Return value is small cluster ID vector which
 // locked here.
 //---------------------------------------------------------
 std::vector<Int_t> DefiniteNHDIs(std::map<Int_t,S4CALSmallCluster*> &sclmap,
				  std::map<Int_t,S4HYBTrack*>        &trkmap);


  ClassDef(S4CALNHDClusterMaker, 1)
};
    
#endif
