#ifndef __S4CDCTRACKMAKER__
#define __S4CDCTRACKMAKER__

//*************************************************************************
//* ---------------------
//* S4CDCTrackMaker Class
//* ---------------------
//* (Description)
//*	This set of classes makes Smearing Hits.
//* (Requires)
//*	JSFModules:
//* (Provides)
//*	S4CDCTrackMaker		: steering class
//* (Update Record)
//*	2001/08/22  K.Hoshina	Original version.
//*************************************************************************

#include "U4CDCTrackMaker.h"
#include "U4CDCKalDetector.h"

class S4CDCTrackMaker : public U4CDCTrackMaker {
public:
  S4CDCTrackMaker(U4CDCKalDetector *det,
                  const Char_t *name="S4CDCTrackMaker",
		  const Char_t *title="CDC Track Maker");
		  
  virtual ~S4CDCTrackMaker();

  virtual Bool_t Initialize();		// job initialization
  virtual Bool_t BeginRun(Int_t run);   //
  virtual Bool_t Process(Int_t  ev) ;	// process event
  inline virtual U4CDCKalDetector* GetDetectorPtr() const { return fDetectorPtr;}
  
private:
  U4CDCKalDetector *fDetectorPtr;

  ClassDef(S4CDCTrackMaker, 1) 	// CDC track maker
};

#endif
