#ifndef __S4ITHITMAKERBUF__
#define __S4ITHITMAKERBUF__
//*************************************************************************
//* ---------------------
//* S4ITHitMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes FADC clusters.
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	S4ITHitMakerBuf		: buffering class
//* (Update Record)
//*	2004/08/07  A.Yamaguchi	Original version.
//*************************************************************************
#include "U4ITHitMakerBuf.h"
#include "S4ITHitMaker.h"


class S4ITHitMakerBuf : public U4ITHitMakerBuf {
public:
  S4ITHitMakerBuf(const Char_t *name   ="S4ITHitMakerBuf",
                  const Char_t *title  ="IT Hit data", 
                  S4ITHitMaker *module = 0,
                  Int_t         size   = 500);

  S4ITHitMakerBuf(S4ITHitMaker *module,
                 const Char_t  *name  = "S4ITHitMakerBuf",
                 const Char_t  *title = "IT Hit data",
                 Int_t          size  = 500);
          
  virtual ~S4ITHitMakerBuf();

  virtual void MakeHits() ;   // Make IT Hits
  virtual void SetInputBufPtr(TObjArray *bufp) { fInputBufPtr = bufp; }
private:  

  TObjArray *fInputBufPtr;

  
  ClassDef(S4ITHitMakerBuf, 1) // Cluster data buffer
};

#endif
