//****************************************************
//*
//*  Dummy UserAnalysis Script to be used with gui.C 
//*  Functions in this scripts are called by GUIMainMacro.C  
//*  
//*  In this script, global functions, UserInitialize() nad UserAnalysis()
//*  Must be defined.  UserInitialize() is called at job initialization 
//*  to initialize histograms, etc.  It is also called when reset historgam
//*  menu is selected from JSF Control Panel.  UserAnalysis() is called 
//*  during the event loop after executing Process functions of JSF modules
//*  and display event daia but before display histogram.  See GetEvent()
//*  function in GUIMainMacro.C, where UserAnalysis() is called.
//*
//*  UserSetOptions() and UserTerminate() may be defined in this file.
//*  UserSetOptions() are called before declaration of JSF modules.
//*  It can be used to set parameters optional for user analsis.
//*  UserTerminate() is called during the JSF termination process.
//*
//*  When runmode=4, UserModuleDefine() must be defined in this file.
//*  It is used to define JSF modules specific to user analysis.  
//*  
//*$Id: UserAnalysis.C,v 1.4 2007/05/07 02:15:39 fujiik Exp $
//*
//****************************************************

//_________________________________________________________
void UserAnotherModules()
{
#if 0 // Now defined in pfoanl.conf
   gSystem->Load("libS4Kalman.so");
   gSystem->Load("libS4Geom.so");
   gSystem->Load("libS4KalTrack.so");
   gSystem->Load("libS4GENMCTruth.so");
   gSystem->Load("libU4VHitMaker.so");
   gSystem->Load("libU4KalDetector.so");
   gSystem->Load("libU4ITKalDetector.so");
   gSystem->Load("libU4ITHitMaker.so");
   gSystem->Load("libU4TPCKalDetector.so");
   gSystem->Load("libU4TPCHitMaker.so");
   gSystem->Load("libS4ITMCTruth.so");
   gSystem->Load("libS4TPCMCTruth.so");
   gSystem->Load("libS4ITHitMaker.so");
   gSystem->Load("libS4TPCHitMaker.so");
   gSystem->Load("libU4VTrackMaker.so");
   gSystem->Load("libS4Kern.so");
   gSystem->Load("libU4ITTrackMaker.so");
   gSystem->Load("libS4ITTrackMaker.so");
   gSystem->Load("libU4TPCTrackMaker.so");
   gSystem->Load("libS4TPCTrackMaker.so");
   gSystem->Load("libU4HYBTrackMaker.so");
   gSystem->Load("libS4HYBTrackMaker.so");
   gSystem->Load("libS4TPCAnalysis.so");
   gSystem->Load("libS4CALMCTruth.so");
   gSystem->Load("libS4CALHitMaker.so");
   gSystem->Load("libS4CALClusterMaker.so");
   gSystem->Load("libS4CALAnalysis.so");
   gSystem->Load("libAnlib.so");
   gSystem->Load("libS4PFOMaker.so");
#endif

//----------------------------------
// Define KalDetector
//----------------------------------

   TKalDetCradle    *cradle      = new TKalDetCradle();
   U4KalDetector    *det         = new U4KalDetector();
   U4TPCKalDetector *tpcdet      = new U4TPCKalDetector("FillLayer");
   U4ITKalDetector  *itdet       = new U4ITKalDetector("FillLayer");
   U4VTXKalDetector *vtxdet      = new U4VTXKalDetector("FillLayer");
   cradle->Install(*det);
   cradle->Install(*tpcdet);
   cradle->Install(*itdet);
   cradle->Install(*vtxdet);
#if 0
   cradle->SwitchOffMS();
#endif

//----------------------------------
//  Insert modules
//----------------------------------

   JSFJ4BufManager   *bufman        = new JSFJ4BufManager();

   S4GENMCTruth      *mctruthgen    = new S4GENMCTruth();
   S4VTXMCTruth      *mctruthvtx    = new S4VTXMCTruth();
   S4ITMCTruth       *mctruthit     = new S4ITMCTruth();
   S4TPCMCTruth      *mctruth       = new S4TPCMCTruth();
   S4CALMCTruth      *calmctruth    = new S4CALMCTruth();

   S4VTXHitMaker     *hitmakervtx   = new S4VTXHitMaker();
   S4ITHitMaker      *hitmakerit    = new S4ITHitMaker();
   S4TPCHitMaker     *hitmaker      = new S4TPCHitMaker();
   S4VTXTrackMaker   *vtxtrackmaker = new S4VTXTrackMaker(vtxdet);
   S4ITTrackMaker    *ittrackmaker  = new S4ITTrackMaker(itdet);
   S4TPCTrackMaker   *tpctrackmaker = new S4TPCTrackMaker(tpcdet);
   S4HYBTrackMaker   *hybtrackmaker = new S4HYBTrackMaker(det);

   S4CALHitMaker     *calhitmaker   = new S4CALHitMaker();
   S4CALClusterMaker *calclustmaker = new S4CALClusterMaker();
   S4PFOMaker        *pfomaker      = new S4PFOMaker();
   S4JetMaker        *jetmaker      = new S4JetMaker();

#if 1
   S4TPCAnalysis     *tpcanalysis   = new S4TPCAnalysis();
   S4CALAnalysis     *calanalysis   = new S4CALAnalysis();
   S4PFOAnalysis     *pfoanalysis   = new S4PFOAnalysis();
   WWAnalysis        *wwanalysis    = new WWAnalysis();
#endif

//----------------------------------
//  Insert modules off 2005/01/07
//----------------------------------
   bufman        -> SetMakeBranch(kFALSE);

   mctruthit     -> SetMakeBranch(kFALSE);
   mctruth       -> SetMakeBranch(kFALSE);
   calmctruth    -> SetMakeBranch(kFALSE);

   hitmakerit    -> SetMakeBranch(kFALSE);
   hitmaker      -> SetMakeBranch(kFALSE);
   ittrackmaker  -> SetMakeBranch(kFALSE);
   tpctrackmaker -> SetMakeBranch(kFALSE);
   hybtrackmaker -> SetMakeBranch(kFALSE);

   calhitmaker   -> SetMakeBranch(kFALSE);
   calclustmaker -> SetMakeBranch(kFALSE);
   pfomaker      -> SetMakeBranch(kFALSE);
   jetmaker      -> SetMakeBranch(kFALSE);

#if 1
   tpcanalysis   -> SetMakeBranch(kFALSE);
   calanalysis   -> SetMakeBranch(kFALSE);
   pfoanalysis   -> SetMakeBranch(kFALSE);
   wwanalysis    -> SetMakeBranch(kFALSE);
#endif
}


//_________________________________________________________
void UserInitialize()
{
//----------------------------------
// set parameters
//----------------------------------
#if 0
   //   S4TPCPadHit::SetSpatialResolution("experimental"); // default is "flat".

   // Set IP constraint ....
   // S4TPCTrack::SetIPConstraint(kTRUE);

   // Artificial bunch tagging
   Double_t t0 = 0.;
   S4TPCTrack::SetT0pedestal(t0); // [ns]
#endif

   S4CALHitBuf::SetHitMakingScheme(1); // idealistic (smeared 1 hit/1 exact hit)

//----------------------------------
// set subtrackers to hybtrackmaker 
//----------------------------------

  S4TPCTrackMaker *tpctrackmaker = (S4TPCTrackMaker *)gJSF->FindModule("S4TPCTrackMaker");
  S4ITTrackMaker  *ittrackmaker  = (S4ITTrackMaker *)gJSF->FindModule("S4ITTrackMaker");
  S4VTXTrackMaker *vtxtrackmaker = (S4VTXTrackMaker *)gJSF->FindModule("S4VTXTrackMaker");
  S4HYBTrackMaker *hybtrackmaker = (S4HYBTrackMaker *)gJSF->FindModule("S4HYBTrackMaker");
  hybtrackmaker->SetMainTrackMakerPtr(tpctrackmaker);
  hybtrackmaker->AddSubTrackMakerPtr(ittrackmaker);
  hybtrackmaker->AddSubTrackMakerPtr(vtxtrackmaker);
}

//_________________________________________________________
void UserAnalysis()
{
  S4PFOMakerBuf *pfombp = (S4PFOMakerBuf *)
                              gJSF->FindModule("S4PFOMaker")->EventBuf();
   //pfombp->DebugPrint();

  S4JetMakerBuf *jetmbp = (S4JetMakerBuf *)
				 gJSF->FindModule("S4JetMaker")->EventBuf();
  jetmbp->DebugPrint();
   //DrawJets(0,"p");  // default jets with PreHits
   DrawJets(2);        // forced 4 jets without PreHits

   S4GENMCTruth *genp = (S4GENMCTruth *)gJSF->FindModule("S4GENMCTruth");
   // genp->DebugPrint("Detailed");
   genp->DebugPrint();
}


static TCanvas     *cvp    = 0;
static TTUBE       *itubep = 0;
static TTUBE       *otubep = 0;
static TRotMatrix  *orotp = 0;
static TNode       *onodep = 0;
static TNode       *inodep = 0;
static Int_t        color  = 0;

//_________________________________________________________
void DrawJets(Int_t njets = 0, const Char_t *opt = "")
{
   TDirectory *last = gDirectory;
//----------------------------------
// initialize event display
//----------------------------------
#if 1
   if (!cvp) {
      cvp = new TCanvas("OED", "Event Display", 400, 10, 610, 610);
   } else {
      cvp->cd();
      cvp->Clear();
   }
#if ROOT_VERSION_CODE < ROOT_VERSION(5,15,4)
   TView   *vwp = new TView(1);
#else
   TView   *vwp = new TView3D();
   vwp->SetSystem(1);
#endif
   vwp->SetRange(-360.,-360.,-360.,+360.,+360.,+360.);
   Int_t ierr;
   vwp->SetView(10.,80.,80.,ierr);
#else
   cvp = (TCanvas *)gROOT->FindObject("EventDisplay");
   if (!cvp) return;
   else      cvp->cd();
#endif

   if (!otubep) otubep = new TTUBE("CALO","CALO","void",350.,350.,410.);
   if (!itubep) itubep = new TTUBE("CALI","CALI","void",210.,210.,270.);
   if (!orotp)  orotp  = new TRotMatrix("orot","orot",10.,80.,10.,80.,10.,80.);
   if (!onodep) {
      onodep = new TNode("ONODE","ONODE","CALO",0.,0.,0.,"orot");
      onodep->cd();
      inodep = new TNode("INODE","INODE","CALI");
   }
   onodep->Draw("pad same");

   TObjArray *jetsp = ((S4JetMakerBuf *)gJSF->FindModule("S4JetMaker")
                         ->EventBuf())->GetJetSetPtr(njets);

   if (jetsp && jetsp->GetEntries()) {
      TIter next(jetsp);
      S4Jet *jetp = 0;
      while ((jetp = (S4Jet *)next())) {
	 color++;
	 color %= 10;
	 jetp->Draw(color,opt);
      }
   }
   last->cd();
}

//_________________________________________________________
void DrawHist()
{
}
