
//*************************************************************************
//* --------------------
//* S4PFOMaker
//* --------------------
//* (Description)
//*	This set of classes makes Particle Flow Objects.
//* (Requires)
//*     JSFModules:
//* (Provides)
//*     S4PFOMaker              : steering class          
//* (Update Record)
//*	2004/09/03  S.Yamamoto	Original version.
//*************************************************************************

#include <iostream>
#include "JSFSteer.h"
#include "S4CALClusterMaker.h"
#include "S4CALClusterMakerBuf.h"
#include "S4PFOMaker.h"
#include "S4PFOMakerBuf.h"

ClassImp(S4PFOMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4PFOMaker::S4PFOMaker(const Char_t *name, const Char_t *title)
       		  : JSFModule(name,title)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

S4PFOMaker::~S4PFOMaker()
{
}

//=====================================================================
//* Initialize --------------------------------------------------------

Bool_t S4PFOMaker::Initialize()
{
   std::cerr << " S4PFOMaker::Initialize called " << std::endl;
   fEventBuf = new S4PFOMakerBuf(this);
   return kTRUE;
}

//=====================================================================
//* BeginRun ----------------------------------------------------------

Bool_t S4PFOMaker::BeginRun(Int_t /* run */ )
{
   return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4PFOMaker::Process(Int_t /* ev */ )
{
   S4CALClusterMaker *cmp = (S4CALClusterMaker *)gJSF->FindModule("S4CALClusterMaker");
   S4CALClusterMakerBuf *cmbufp = (S4CALClusterMakerBuf *)cmp->EventBuf();
   S4PFOMakerBuf *pfobufp = (S4PFOMakerBuf *)EventBuf();
   pfobufp->SetInputDataBufPtr(cmbufp);
   pfobufp->MakePFOs();
   return kTRUE;
}
