#ifndef __U4HYBTRACK__
#define __U4HYBTRACK__

//*************************************************************************
//* ----------------
//* U4HYBTrack Class
//* ----------------
//* (Description)
//*	Class to represent a hybrid track.
//* (Requires)
//*	U4VTrack
//* (Provides)
//*	U4HYBTrack
//* (Update Record)
//*	2004/09/07  K.Fujii         Original version.
//*************************************************************************

#include "U4VTrack.h"
#include "U4HYBTrackMaker.h"

class U4HYBTrack : public U4VTrack {
public:
  // ----------------------------------------------------------------------
  // C-tors and D-tor 
  // ----------------
  U4HYBTrack(U4VTrackMaker *trkmp = 0);
  virtual ~U4HYBTrack();

  // ----------------------------------------------------------------------
  // ---------------------------------
  //  Virtuals of U4VTrack to override
  // ---------------------------------
  virtual Int_t             GetNhits          ()                 const;

  virtual void              DebugPrint        (const Char_t *opt = "");
  virtual void              MakeKalHits(TObjArray &kalhits);
  virtual TKalTrackSite   * GetFirstSitePtr(Bool_t     isBackward,
                                            TObjArray *hitsp = 0);
  virtual void              Add(U4VTrack *obj);

  virtual void              KalmanFilter      (Bool_t isBackward = kIterBackward);
  
  // ----------------------------------------------------------------------
  // -------------------
  // Data members if any
  // -------------------
private:

  ClassDef(U4HYBTrack, 1)		   // Baby Track
};

// ------------------------------------------------------------------------
//  Inline function if any
// ------------------------------------------------------------------------

#endif
