//*************************************************************************
//* --------------------
//* U4VHitMakerBuf
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2001/08/22  K.Hoshina	Original version.
//*************************************************************************

#include "U4VHitMakerBuf.h"


ClassImp(U4VHitMakerBuf)

//=====================================================================
//* constructor -------------------------------------------------------
U4VHitMakerBuf::U4VHitMakerBuf(const char *name, const char *title, 
			       U4VHitMaker *module, Int_t bufsize) 
		    :JSFEventBuf(name, title, (JSFModule*)module),
		     fDone(kFALSE), fOutputBuf(bufsize),fInputDataBufPtr(0)
{
}

U4VHitMakerBuf::U4VHitMakerBuf(U4VHitMaker *module, const char *name, 
			       const char *title, Int_t bufsize)
		    :JSFEventBuf(name, title, (JSFModule*)module),
		     fDone(kFALSE), fOutputBuf(bufsize),fInputDataBufPtr(0)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

U4VHitMakerBuf::~U4VHitMakerBuf()
{
	fOutputBuf.Delete();
}

//=====================================================================
//* GetOutputBufPtr ------------------------------------------------------

TObjArray* U4VHitMakerBuf::GetOutputBufPtr()
{
	return &fOutputBuf;
}

//=====================================================================
//* GetEntries --------------------------------------------------------

Int_t U4VHitMakerBuf::GetEntries()
{
	return fOutputBuf.GetEntries();
}

//=====================================================================
//* SetInputDataBuf ---------------------------------------------------

void U4VHitMakerBuf::SetInputDataBufPtr(JSFEventBuf *buf)
{
	fDone            = kFALSE;
	fInputDataBufPtr = buf;
	if (fOutputBuf.GetEntries() > 0) fOutputBuf.Delete();
}





