//*************************************************************************
//* ---------------------
//* U4VKalDetector Class
//* ---------------------
//* (Description)
//*     Class to store "U4TPCMeasLayer"
//* (Requires)
//* (Provides)
//* (Update Record)
//*     2004/08/26   A.Yamaguchi   Original Version.
//*************************************************************************

#include "U4VKalDetector.h"
#include "U4VMeasLayer.h"

ClassImp(U4VKalDetector)

Double_t U4VKalDetector::fgBfield=30.0; // kGauss unit, solenoid field.


//=====================================================================
//* constructor -------------------------------------------------------

U4VKalDetector::U4VKalDetector(Int_t m)
              : TVKalDetector(m)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

U4VKalDetector::~U4VKalDetector()
{
}

//=====================================================================
//* GetNmeasPoints ----------------------------------------------------

Int_t U4VKalDetector::GetNmeasPoints() const
{
   Int_t n = 0;
   TIter next(this);
   U4VMeasLayer *mlp = 0;
   while ((mlp = dynamic_cast<U4VMeasLayer *>(next()))) {
      if (mlp->IsActive()) n++;
   }
   return n;
}

//=====================================================================
//* GetBfield ---------------------------------------------------------

Double_t U4VKalDetector::GetBfield(Int_t /*index*/) const
{
  //   static const Double_t bfield = 30.;   // [kG]
   return fgBfield;
}
