#ifndef __U4VTRACKMAKER__
#define __U4VTRACKMAKER__

//*************************************************************************
//* ---------------------
//* U4VTrackMaker Class
//* ---------------------
//* (Description)
//*	This set of classes makes Smearing Hits.
//* (Requires)
//*	JSFModules:
//* (Provides)
//*	U4VTrackMaker		: steering class
//* (Update Record)
//*	2001/08/22  K.Hoshina	Original version.
//*	2004/09/06  K.Fujii	Added GetDetectorPtr() and fDetectorPtr.
//*************************************************************************


#include "JSFModule.h"
#include "U4VKalDetector.h"

class U4VTrackMaker : public JSFModule {
public:
  U4VTrackMaker(const Char_t *name,
                const Char_t *title);
  U4VTrackMaker(U4VKalDetector *det,
                const Char_t   *name,
                const Char_t   *title);
  virtual ~U4VTrackMaker();

  virtual Bool_t BeginRun(Int_t run);   // process Begin Run record
  virtual Bool_t Process (Int_t  ev);   // process event

  virtual U4VKalDetector *GetDetectorPtr() const { return fDetectorPtr; }
  virtual U4VKalDetector *GetDetectorPtr()       { return fDetectorPtr; }
  virtual void SetDetector(U4VKalDetector &det)  { fDetectorPtr = &det; }

private:
  U4VKalDetector *fDetectorPtr;    //! pointer to detector

  ClassDef(U4VTrackMaker, 1)  //  hit maker
};

#endif
