#ifndef __U4VTRACKMAKERBUF__
#define __U4VTRACKMAKERBUF__

//*************************************************************************
//* ---------------------
//* U4VTrackMakerBuf Class
//* ---------------------
//* (Description)
//*	
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	U4VTrackMakerBuf		: buffering class
//* (Update Record)
//*	1999/12/04  K.Fujii	Original version.
//*************************************************************************

#include "TObjArray.h"
#include "U4VTrackMaker.h"
class U4VTrack;

class U4VTrackMakerBuf : public JSFEventBuf {
friend class U4VTrackMaker;

public:

  U4VTrackMakerBuf(const char *name, const char *title, 
		   U4VTrackMaker *mod=0, Int_t bufsize = 2000);
  U4VTrackMakerBuf(U4VTrackMaker *mod, const char *name, 
  		   const char *title, Int_t bufsize = 2000);
  		    
  virtual ~U4VTrackMakerBuf();
  
  virtual void 	DebugPrint(const Char_t *opt = "") {};
  
  inline virtual Bool_t IsDone() const { return fDone; }
  inline virtual Bool_t IsInitialized() const
  {
      if (fInputDataBufPtr) return kTRUE;
      else                  return kFALSE;
  }
  
  virtual TObjArray*   GetOutputBufPtr() ; // returns array of cluster hit
  virtual Int_t	       GetEntries();	   // returns number of entries of fHits
  JSFEventBuf *        GetInputDataBufPtr() { return fInputDataBufPtr ;} //
  
  inline  virtual void SetDone        ( Bool_t done ) { fDone = done; } // 
  virtual void         SetInputDataBufPtr( JSFEventBuf* buf ) ;		//
  
  // very temporary !!!
  virtual U4VTrack*    MakeOneTrack(U4VTrack *trkp) { return 0; }  

private:  
  virtual void	MakeTracks() = 0 ; 	// Make Hits
							     
protected:

  
  Bool_t	fDone;	 		// (1,0) = (clustering done, not yet)
  TObjArray	fOutputBuf; 		// Output data buffer
  JSFEventBuf  *fInputDataBufPtr;	// Input data buffer 
  

  ClassDef(U4VTrackMakerBuf, 1) // Cluster data buffer
};



#endif















